'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = isMixinName;

var _globals = require('./globals');

var unpaddedFractionalNumbersPattern = /\.[0-9]/;

function isMixinName(str) {
    var firstSymbolCode = str ? str[0].charCodeAt(0) : null;

    return (firstSymbolCode === _globals.dot || firstSymbolCode === _globals.hash) &&

    // ignore hashes used for colors
    _globals.hashColorPattern.test(str) === false &&

    // ignore dots used for unpadded fractional numbers
    unpaddedFractionalNumbersPattern.test(str) === false;
}
module.exports = exports['default'];