'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = tokenizeDefault;

var _globals = require('./globals');

var _isEscaping = require('./is-escaping');

var _isEscaping2 = _interopRequireDefault(_isEscaping);

var _isMixinName = require('./is-mixin-name');

var _isMixinName2 = _interopRequireDefault(_isMixinName);

var _tokenizeInlineComment = require('./tokenize-inline-comment');

var _tokenizeInlineComment2 = _interopRequireDefault(_tokenizeInlineComment);

var _tokenizeMultilineComment = require('./tokenize-multiline-comment');

var _tokenizeMultilineComment2 = _interopRequireDefault(_tokenizeMultilineComment);

var _tokenizeNestedExtend = require('./tokenize-nested-extend');

var _tokenizeNestedExtend2 = _interopRequireDefault(_tokenizeNestedExtend);

var _tokenizeNestedMixin = require('./tokenize-nested-mixin');

var _tokenizeNestedMixin2 = _interopRequireDefault(_tokenizeNestedMixin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function tokenizeDefault(state) {
    // it's a nested &:extend
    if (state.symbolCode === _globals.ampersand && state.css.slice(state.pos, state.pos + _globals.nestedExtendWordLength) === _globals.nestedExtendWord) {
        (0, _tokenizeNestedExtend2.default)(state);
    } else {
        state.nextSymbolCode = state.css.charCodeAt(state.pos + 1);

        if (state.symbolCode === _globals.slash && state.nextSymbolCode === _globals.asterisk) {
            (0, _tokenizeMultilineComment2.default)(state);
        } else if (state.symbolCode === _globals.slash && state.nextSymbolCode === _globals.slash) {
            (0, _tokenizeInlineComment2.default)(state);
        } else {
            if ((0, _isEscaping2.default)(state) === false) {
                _globals.wordEndPattern.lastIndex = state.pos + 1;
                _globals.wordEndPattern.test(state.css);
                if (_globals.wordEndPattern.lastIndex === 0) {
                    state.nextPos = state.css.length - 1;
                } else {
                    state.nextPos = _globals.wordEndPattern.lastIndex - 2;
                }
            }

            state.cssPart = state.css.slice(state.pos, state.nextPos + 1);

            var tokensCount = state.tokens.push(['word', state.cssPart, state.line, state.pos - state.offset, state.line, state.nextPos - state.offset]);

            /**
             * - mark nested mixin by custom token
             * - skip variables that start from dot (.5s) or from hash (#f3f3f3)
             */
            if ((0, _isMixinName2.default)(state.cssPart) && (state.tokens[tokensCount - 2] || [])[1] !== ':' && (state.tokens[tokensCount - 3] || [])[1] !== ':') {
                (0, _tokenizeNestedMixin2.default)(state);
            }

            state.pos = state.nextPos;
        }
    }
}
module.exports = exports['default'];